/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_bg.c
 *  Content	:wiANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/2/2
 *  UpDate	:2004/2/2
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actScroll(ACT* actp);

void
actBg(ACT* actp)
{
	switch(actp->step) {
	/*  */
	case 0:
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* t[Awi̐𐶐 */
		ACTsetBtm(actScroll, GROUP_EFFECT);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

void
actFrame(ACT* actp)
{
	int pos_x;

	switch(actp->step) {
	/*  */
	case 0:
		actp->pos[X] = 0.0f;
		actp->wait = 60;
		ACTnextStep();
		break;

	/* C */
	case 1:
		pos_x = actp->pos[X];
		DrawBox(  0      , 0, 320-pos_x, 480, 2);
		DrawBox(320+pos_x, 0, 640      , 480, 2);
		if(actp->wait) {
			actp->wait--;
		} else {
			actp->wait = 60;
			ACTnextStep();
		}
		break;
	case 2:
		pos_x = actp->pos[X];
		DrawBox(  0      , 0, 320-pos_x, 480, 2);
		DrawBox(320+pos_x, 0, 640      , 480, 2);
		if(actp->wait) {
			actp->pos[X] += (640.0f - 256.0f) / 2.0f / 60;
			actp->wait--;
		} else {
			actp->pos[X]  = (640.0f - 256.0f) / 2.0f;
			ACTnextStep();
		}
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actScroll(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		pos[X]  = rand() % (640 - 256 - 16);
		pos[X] -=          (640 - 256 - 16) / 2;
		actp->pos[X] = 320.0f + pos[X];
		actp->pos[Y] = -16.0f;
		pos[Y]  = rand() % (int)(FVAL * 4);	/* (FVAL*0)`(FVAL*4-1) */
		pos[Y] += FVAL;				/* (FVAL*1)`(FVAL*5-1) */
		actp->vel[Y] = pos[Y] / FVAL;		/* 1`4.99 */
		ACTnextStep();
		break;

	/* C */
	case 1:
		actp->pos[Y] += actp->vel[Y];
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		DrawString(pos[X], pos[Y], "", 2);
		if(actp->pos[Y] > (480.0f + 16.0f)) {
			ACTexitStep();
		}
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

void
actQuake(ACT* actp)
{
	switch(actp->step) {
	/*  */
	case 0:
		actp->wait  = actp->cnt;
		actp->wait /= 2;
		ACTnextStep();
		break;

	/* C */
	case 1:
		if(actp->cnt) {
			actp->cnt--;
		} else {
			scr_pos[X] = 0.0f;
			scr_pos[Y] = 0.0f;
			ACTexitStep();
			break; /* ܂ */
		}
		/* FVALł͑傫rand()̏]Ƃɕ΂肪łĂ܂̂ŁA256.0fƂĂ */
		actp->pos[X]  = (rand() % (int)(256.0f * actp->vel[X]) - (256.0f * actp->vel[X] / 2)) / 256.0f;	/* -vel[X]/2`+vel[X]/2 */
		actp->pos[Y]  = (rand() % (int)(256.0f * actp->vel[Y]) - (256.0f * actp->vel[Y] / 2)) / 256.0f;	/* -vel[Y]/2`+vel[Y]/2 */
		actp->vel[X] -= actp->vel[X] / actp->wait;
		actp->vel[Y] -= actp->vel[Y] / actp->wait;
		scr_pos[X] = actp->pos[X];
		scr_pos[Y] = actp->pos[Y];
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

