/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_ene00.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/3/6
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actEnemy00Int(ACT* actp);
static void actChip(ACT* actp);
static void actChipInt(ACT* actp);

void
actEnemy00(ACT* actp)
{
	int pos[XY];
	int color;

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_ENEMY;
		actp->col[X] = 3 * 9;
		actp->col[Y] = 32.0f;
		actp->energy = 5;
		actp->int_adr = actEnemy00Int;
		actp->bul_vel[X] = 0.0f;
		actp->bul_vel[Y] = 0.0f;
		actp->bul_acc[X] = 0.0f;
		actp->bul_acc[Y] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		if(actp->cnt & 0x01) {
			actp->pos[X] = SCR_SX + 32;
		} else {
			actp->pos[X] = SCR_EX - 32;
		}
		actp->pos[Y] = -16.0f;
		actp->vel[X] = 0.0f;
		actp->vel[Y] = 1.0f;
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[X] += actp->vel[X];
		actp->pos[Y] += actp->vel[Y];
		if(actp->pos[Y] > (480.0f+16.0f)) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 3 * 9 / 2;
		pos[Y] -= 16;
		if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
			color = 0;
		} else {
			actp->actid &= ~ACTF_MUTEKI;
			color = 1;
		}
		DrawString(pos[X], pos[Y], "[=]", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "[=]", color);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actEnemy00Int(ACT* actp)
{
	ACT* eactp = actp->ext_dat;

	if(tstFLG(eactp->actid, ACTF_SSHOT)) {
		actSetParticle(eactp);
	} else {
		actSetParticle(actp);
	}
	if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
		actp->actid  |= ACTF_MUTEKI;
		actp->energy -= eactp->energy;
		score += 1;
		if(actp->energy <= 0) {
			actp->actid &= ~ACTF_ENEMY;
			eactp = ACTsetTop(actChip, GROUP_ENEMY);
			eactp->pos[X] = actp->pos[X];
			eactp->pos[Y] = actp->pos[Y];
			eactp->cnt = actp->cnt;
			soundPlaySe(SE_EXP00);
			ACTexitStep();
			score += 1;
		}
	}
}

static void
actChip(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_CHIP;
		actp->col[X] = 32.0f;
		actp->col[Y] = 32.0f;
		actp->energy = 10;
		actp->int_adr = actChipInt;
		actp->bul_vel[X] = 0.0f;
		actp->bul_vel[Y] = 0.0f;
		actp->bul_acc[X] = 0.0f;
		actp->bul_acc[Y] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		actp->vel[X] = 0.0f;
		actp->vel[Y] = 1.0f;
		if(!actp->cnt || (actp->cnt % 0x08)) {
			actp->cnt = 0;
		} else {
			actp->cnt = 1;
		}
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[X] += actp->vel[X];
		actp->pos[Y] += actp->vel[Y];
		if(actp->pos[Y] > (480.0f+16.0f)) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 1 * 9 / 2;
		pos[Y] -= 16;
		if(frame & 0x01) {
			if(!actp->cnt) {
				DrawString(pos[X], pos[Y], "P", 0);
			} else {
				DrawString(pos[X], pos[Y], "B", 0);
			}
		}
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actChipInt(ACT* actp)
{
	actp->actid &= ~ACTF_CHIP;
	ACTexitStep();
}

