/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_ene05.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/3/11
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actEnemy05Int(ACT* actp);

void
actEnemy05(ACT* actp)
{
	int pos[XY];
	int color;

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_ENEMY;
		actp->col[X] = 3 * 9;
		actp->col[Y] = 32.0f;
		actp->energy = 10;
		actp->int_adr = actEnemy05Int;
		actp->bul_vel[X] = 0.0f;
		actp->bul_vel[Y] = 0.0f;
		actp->bul_acc[X] = 0.0f;
		actp->bul_acc[Y] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		BulletMLgetShipDist(actp, actp->vel);
		actp->vel[X] /=  360.0f;
		actp->vel[Y] /= -360.0f;
		BulletMLaddCtrl(actp, 4);
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[X] += actp->vel[X];
		actp->pos[Y] += actp->vel[Y];
		if(actp->pos[Y] > (480.0f+16.0f)) {
			ACTexitStep();
			break; /* ܂ */
		}
		if(actp->pos[X] < (SCR_SX-16.0f)) {
			ACTexitStep();
			break; /* ܂ */
		}
		if(actp->pos[X] > (SCR_EX+16.0f)) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* e */
		BulletMLexecCtrl(actp);
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 3 * 9 / 2;
		pos[Y] -= 16;
		if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
			color = 0;
		} else {
			actp->actid &= ~ACTF_MUTEKI;
			color = 1;
		}
		DrawString(pos[X], pos[Y], "H+H", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "U|U", color);
		break;

	/* I */
	default:
		ACTclear(actp);
		enemy_cnt--;
		break;
	}
}

static void
actEnemy05Int(ACT* actp)
{
	ACT* eactp = actp->ext_dat;

	if(tstFLG(eactp->actid, ACTF_SSHOT)) {
		actSetParticle(eactp);
	} else {
		actSetParticle(actp);
	}
	if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
		actp->actid  |= ACTF_MUTEKI;
		actp->energy -= eactp->energy;
		score += 1;
		if(actp->energy <= 0) {
			actp->actid &= ~ACTF_ENEMY;
			soundPlaySe(SE_EXP01);
			ACTexitStep();
			score += 1;
			actEnemyChkDest();
		}
	}
}

