/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_enemy.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/2/3
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actEnemyBulletInt(ACT* actp);

void
actParticle(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->vel[X]  = (rand() % (int)(FVAL * 8) - (FVAL * 4)) / FVAL;	/* -4.00`+3.99 */
		actp->vel[Y]  = (rand() % (int)(FVAL * 8) - (FVAL * 4)) / FVAL;	/* -4.00`+3.99 */
		actp->vel[X] *= 2.0f;
		actp->vel[Y] *= 2.0f;
		actp->wait = 15;
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[X] += actp->vel[X];
		actp->pos[Y] += actp->vel[Y];
		if(actp->wait) {
			actp->wait--;
		} else {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X] - (1 *  9 / 2);
		pos[Y] = scr_pos[Y] + actp->pos[Y] - (1 * 16 / 2);
		DrawString(pos[X], pos[Y],"", 0);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}

}

void
actSetParticle(ACT* actp)
{
	int lp1;
	ACT* eactp;

	for(lp1 = 0; lp1 < 4; lp1++) {
		eactp = ACTsetBtm(actParticle, GROUP_EFFECT);
		eactp->pos[X] = actp->pos[X];
		eactp->pos[Y] = actp->pos[Y];
		eactp->prog_adr(eactp);
	}
}

void
actEnemyBullet(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid |= ACTF_ESHOT;
		//actp->col[X] = 2.0f;
		//actp->col[Y] = 2.0f;
		//Sat Dec 09 18:08:52 JST 2006 Naoyuki Sawa
		actp->col[X] = 4.0f;
		actp->col[Y] = 4.0f;
		actp->int_adr = actEnemyBulletInt;
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		BulletMLexecCtrl(actp);
		actp->bul_vel[X] = sin(actp->bul_rot[W]) * (+actp->bul_vel[W]);
		actp->bul_vel[Y] = cos(actp->bul_rot[W]) * (-actp->bul_vel[W]);
		actp->pos[X] += actp->bul_vel[X];
		actp->pos[Y] += actp->bul_vel[Y];
		actp->pos[X] += actp->bul_acc[X];
		actp->pos[Y] += actp->bul_acc[Y];
		if((actp->pos[X] < (128.0f-16.0f)) || (actp->pos[X] > (640.0f-128.0f+16.0f))) {
			ACTexitStep();
			break; /* ܂ */
		}
		if((actp->pos[Y] < -16.0f) || (actp->pos[Y] > (480.0f+16.0f))) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X] - (1 *  9 / 2);
		pos[Y] = scr_pos[Y] + actp->pos[Y] - (1 * 16 / 2);
		DrawString(pos[X], pos[Y], "o", 0);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actEnemyBulletInt(ACT* actp)
{
	score += 1;
	actSetParticle(actp);
	actp->actid &= ~ACTF_ESHOT;
	ACTexitStep();
}

void
actEnemyChkDest()
{
	rankAdd(0.001f);
	if(!(++enemy_dest % 0x20)) {
		ACT* eactp = ACTsetTop(actEnemy00, GROUP_ENEMY);
		eactp->cnt = enemy_carry++; /* bit0 = Left/Right, bit3 = Power/Bomb */
	}
}

void
actClrEnemy(ACT* actp)
{
	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_BOMB;
		actp->energy = 1;
		actp->pos[X] = 320.0f;
		actp->pos[Y] = 240.0f;
		actp->col[X] = 640.0f - (128.0f * 2.0f);
		actp->col[Y] = 480.0f;
		ACTnextStep();
		break;

	/* C */
	case 1:
		ACTexitStep();
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

