/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_ene08.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/3/14
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actEnemy08Int(ACT* actp);

void
actEnemy08(ACT* actp)
{
	int pos[XY];
	int color;

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_ENEMY;
		actp->col[X] = 1 * 9;
		actp->col[Y] = 32.0f;
		actp->energy = 3;
		actp->int_adr = actEnemy08Int;
		actp->bul_vel[X] = 0.0f;
		actp->bul_vel[Y] = 0.0f;
		actp->bul_acc[X] = 0.0f;
		actp->bul_acc[Y] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		actp->bul_rot[W] = 0.0f;
		if(actp->pos[X] < 320.0f) {
			actp->trg[X] = actp->pos[X] + 192.0f;
		} else {
			actp->trg[X] = actp->pos[X] - 192.0f;
		}
		actp->trg[Y] = 480.0f + 32.0f;
		BulletMLaddCtrl(actp, 7);
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		actp->pos[X] += (actp->trg[X] - actp->pos[X]) / 30.0f;
		actp->pos[Y] += (actp->trg[Y] - actp->pos[Y]) / 30.0f;
		if(actp->pos[Y] > (480.0f+16.0f)) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* e */
		BulletMLexecCtrl(actp);
		/* \ */
		pos[X] = scr_pos[X] + actp->pos[X];
		pos[Y] = scr_pos[Y] + actp->pos[Y];
		pos[X] -= 1 * 9 / 2;
		pos[Y] -= 16;
		if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
			color = 0;
		} else {
			actp->actid &= ~ACTF_MUTEKI;
			color = 1;
		}
		DrawString(pos[X], pos[Y], "M", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "|", color);
		break;

	/* I */
	default:
		ACTclear(actp);
		enemy_cnt--;
		break;
	}
}

static void
actEnemy08Int(ACT* actp)
{
	ACT* eactp = actp->ext_dat;

	if(tstFLG(eactp->actid, ACTF_SSHOT)) {
		actSetParticle(eactp);
	} else {
		actSetParticle(actp);
	}
	if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
		actp->actid  |= ACTF_MUTEKI;
		actp->energy -= eactp->energy;
		score += 1;
		if(actp->energy <= 0) {
			actp->actid &= ~ACTF_ENEMY;
			soundPlaySe(SE_EXP01);
			ACTexitStep();
			score += 1;
			actEnemyChkDest();
		}
	}
}

