/*==========================================================================
 *
 *  Copyright (C) 2003 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:bulletml.c
 *  Content	:BulletML֘A
 *  Program	:J.Issiki
 *  Date	:2003/8/23
 *  UpDate	:2004/2/3
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static BulletMLNode* bulletml[BULLETML_MAX];
static ACT* ship_actp;

void
BulletMLreadFiles(int num, const char* fname)
{
	bulletml[num] = BulletML_load(fname);
}

void
BulletMLaddCtrl(ACT* actp, int num)
{
	if(!actp) return;

	BulletMLdelCtrl(actp); /* Ô */
	actp->bullet = BulletMLBullet_new(&BulletCommand, actp, bulletml[num], NULL);
}

void
BulletMLexecCtrl(ACT* actp)
{
	if(!actp) return;

	if(actp->bullet) {
		if(!BulletMLBullet_run(actp->bullet)) {
			BulletMLdelCtrl(actp);
		}
	}
}

int
BulletMLisEnd(ACT* actp)
{
	return !actp || !actp->bullet;
}

void
BulletMLdelCtrl(ACT* actp)
{
	if(!actp) return;

	BulletMLBullet_delete(actp->bullet/*NULLOK*/);
	actp->bullet = NULL;
}

void
BulletMLsetShipAct(ACT* actp)
{
	if(!actp) return;

	ship_actp = actp;
}

void
BulletMLgetShipDist(ACT* actp, float pos[/*XY*/])
{
	if(!actp || !ship_actp) return;

	pos[X] = ship_actp->pos[X] - actp->pos[X];
	pos[Y] = actp->pos[Y] - ship_actp->pos[Y];
}

